/*
 * Nyolc királynő probléma megoldással backtrack algoritmussal
 * Okos tábla, buta királynő
 *
 * Ebben a példában az algoritmus fontosabb, mint OO jelleg.
 */

#include <iostream>

using std::cout;
using std::endl;

class Tabla {
    bool sor[8];
    bool f_atlo[15];
    bool m_atlo[15];
    int  tab[8];
    int  probalkozas;

    bool& Sor(int i) { return sor[i-1]; }
    bool& Fo(int s, int o) { return f_atlo[s-o+7]; }
    bool& Mellek(int s, int o) { return m_atlo[s+o-2]; }
    int&  Tab(int s) { return tab[s-1]; }
    bool Szabad(int s, int o) {
        return Sor(s) && Fo(s, o) && Mellek(s, o);
    }
    void Lefoglal(int s, int o) {
        Sor(s) = Fo(s, o) = Mellek(s, o) = false;
        Tab(s) = o;
    }
    void Felszabadit(int s, int o) {
        Sor(s) = Fo(s, o) = Mellek(s, o) = true;
        Tab(s) = 0;
    }
public:
    Tabla();
    bool Probal(int oszlop);
    void Rajzol(int sor, int oszlop);
};

Tabla::Tabla() {
    for (int i = 0; i < 15; i++) {
        f_atlo[i] = m_atlo[i] = true;
        if (i < 8) {
            sor[i] = true;
            tab[i] = 0;
        }
    }
    probalkozas = 0;
}
bool Tabla::Probal(int oszlop) {
    int sor = 1;
    bool siker = false;
    do {
        Rajzol(sor, oszlop);
        if (Szabad(sor, oszlop)) {
            Lefoglal(sor, oszlop);
            if (oszlop < 8)
                siker = Probal(oszlop+1);
            else
                siker = true;
            if (!siker)
                Felszabadit(sor, oszlop);
        }
        sor++;
    } while (!siker && sor <= 8);
    return siker;
}

void Tabla::Rajzol(int sor, int oszlop) {
    cout.width(3);
    cout << ++probalkozas << ".\n";
    for (int i = 1; i <= 8; i++) {
      cout.width(5);
      cout << 9-i << '|';
      for (int j = 1; j <= 8; j++) {
        if (i == sor && j == oszlop)
            cout << "?|";
	    else if (Tab(i) == j)
            cout << "*|";
   	    else
            cout << " |";
	  }
      cout << endl;
	}
    cout << "      A B C D E F G H\n\n";
}

int main() {
    Tabla t;

    if (t.Probal(1)) {
        t.Rajzol(8, 0);
        cout << "Siker";
    } else
        cout << "Baj van";
}
